#include <stdlib.h>
#include <error.h>
#include <errno.h>
#include <unistd.h>
#include <paths.h>
#include <fcntl.h>
#include <sys/stat.h>

#include "fixfds.h"

void
fix_fds (void)
{
	struct stat stb;

	if ((fstat (STDIN_FILENO, &stb) < 0)
	    && (open (_PATH_DEVNULL, O_RDONLY) != STDIN_FILENO))
		error (EXIT_FAILURE, errno, "open: %s", _PATH_DEVNULL);

	if ((fstat (STDOUT_FILENO, &stb) < 0)
	    && (open (_PATH_DEVNULL, O_WRONLY) != STDOUT_FILENO))
		error (EXIT_FAILURE, errno, "open: %s", _PATH_DEVNULL);

	if ((fstat (STDERR_FILENO, &stb) < 0)
	    && (open (_PATH_DEVNULL, O_WRONLY) != STDERR_FILENO))
		error (EXIT_FAILURE, errno, "open: %s", _PATH_DEVNULL);
}
